diff -rupN /usr/src/linux-2.4.9/fs/reiserfs/raw.c linux-kgdb/fs/reiserfs/raw.c
--- /usr/src/linux-2.4.9/fs/reiserfs/raw.c	Thu Jan  1 03:00:00 1970
+++ linux-kgdb/fs/reiserfs/raw.c	Sat Aug 25 17:18:42 2001
@@ -0,0 +1,639 @@
+/*
+ * fs/reiserfs/raw.c
+ *
+ * "Raw" reiserfs tree interface: access files by their objectid,
+ * bypassing directories.
+ *
+ * The primary target of this is Squid proxy cache acceleration,
+ * but it may have other uses, who knows.
+ *
+ * See Documentation/filesystems/reiserfs_raw.txt for more details.
+ *
+ * Idea from Nikita Danilov <nikitadanilov@yahoo.com>
+ * Written by Yury Shevchuk <sizif@botik.ru>
+ *
+ * Copyright 2000 by Hans Reiser, licensing governed by reiserfs/README
+ *
+ * $Id: raw.c,v 1.1.2.16 2000/12/22 08:52:04 sizif Exp $
+ */
+
+#include <linux/sched.h>
+#include <linux/file.h>
+#include <linux/reiserfs_fs.h>
+#include <linux/smp_lock.h>
+#include <asm/uaccess.h>
+
+static struct inode * reiserfs_raw_new_inode (struct reiserfs_transaction_handle *th,
+					      struct inode *dir,
+					      struct cpu_key *key,
+					      struct inode *inode,
+					      struct reiserfs_raw_ioctl_arg *ra,
+					      int * err);
+static void reiserfs_raw_id_correct (struct reiserfs_raw_ioctl_arg *ra);
+
+
+/* Create raw file.  Arguments are a directory inode (used only to
+   find superblock, so you can opendir() any directory on the fs), and
+   the user arguments structure (see reiserfs_fs.h) */
+
+int
+reiserfs_rawcreat (struct inode * dir, struct vfsmount *mnt,
+		   struct reiserfs_raw_ioctl_arg *ra)
+{
+    struct super_block *sb = dir->i_sb;
+    struct file *filp;
+    struct inode *inode;
+    struct dentry *dentry;
+    struct cpu_key key;
+    struct reiserfs_transaction_handle th;
+    int jbegin_count = JOURNAL_PER_BALANCE_CNT * 2;
+    int windex;
+    int error;
+    int fd;
+
+    if (! reiserfs_raw (sb))
+	return -EPERM;
+    if (INODE_PKEY(dir)->k_objectid != REISERFS_ROOT_OBJECTID ||
+	INODE_PKEY(dir)->k_dir_id != REISERFS_ROOT_PARENT_OBJECTID)
+	return -EPERM;
+    if ((error = permission (dir, MAY_WRITE)))
+	return error;
+
+    fd = get_unused_fd();
+    if (fd < 0)
+	return fd;
+
+    /*
+     * Along the lines of reiserfs_create, but don't reiserfs_add_entry
+     */
+
+    inode = get_empty_inode() ;
+    if (!inode) {
+	error = -ENOMEM;
+	goto cleanup_fd;
+    }
+
+    journal_begin (&th, sb, jbegin_count) ;
+    windex = push_journal_writer("rawcreat") ;
+
+    /* make key for new stat data */
+    reiserfs_raw_id_correct (ra);
+    _make_cpu_key (&key, ITEM_VERSION_2,
+		   le32_to_cpu (ra->id1),
+		   le32_to_cpu (ra->id2),
+		   SD_OFFSET, TYPE_STAT_DATA, 3/*key length*/);
+    inode = reiserfs_raw_new_inode (&th, dir, &key, inode, ra, &error);
+    if (!inode)
+	goto cleanup_journal;	/* reiserfs_new_inode iput()s on error */
+	
+    inode->i_op = &reiserfs_file_inode_operations;
+    inode->i_fop = &reiserfs_file_operations;
+    inode->i_mapping->a_ops = &reiserfs_address_space_operations ;
+
+    /* Now we need to build the file structure.  This is normally done
+       using filp_open(), but that would go through namei and require
+       a filename which we don't have.  So we create a dummy dentry,
+       which is very conveniently done using d_alloc_root().  We don't
+       put the dentry in the dentry hash: it has no name and is
+       useless there.  It will be freed on file close: fput -> __fput
+       -> dput */
+
+    dentry = d_alloc_root(inode);
+    if (! dentry)
+	goto cleanup_inode;
+
+    filp = dentry_open(dentry, mntget(mnt), O_RDWR);
+    error = PTR_ERR(filp);
+    if (IS_ERR(filp))
+	goto cleanup_inode;
+
+    pop_journal_writer(windex) ;
+    journal_end(&th, sb, jbegin_count) ;
+
+    pgc_process_unlinkq (sb);
+    fd_install(fd, filp);
+    return fd;
+
+ cleanup_inode:
+    iput (inode);
+ cleanup_journal:
+    pop_journal_writer(windex) ;
+    journal_end(&th, sb, jbegin_count) ;
+    pgc_process_unlinkq (sb);
+ cleanup_fd:
+    put_unused_fd (fd);
+    return error;
+}
+
+/* Open raw file.  rawopen opens a file by key (not filename), and also
+   returns some of the file attributes (the ones squid wants).  This
+   choice of attributes is squid specific optimization, and users are
+   encouraged to ask us to generalize this interface for other
+   applications.  
+
+   Arguments are a directory inode (must be the root directory of the
+   fs mounted with -o raw), and the user arguments structure (see
+   reiserfs_fs.h) */
+
+int
+reiserfs_rawopen (struct inode * dir, struct vfsmount *mnt,
+		  struct reiserfs_raw_ioctl_arg *ra)
+{
+    int error;
+    struct cpu_key key;
+    struct file *filp;
+    struct inode *inode;
+    struct dentry *dentry;
+    struct super_block *sb = dir->i_sb;
+    int fd;
+
+    if (! reiserfs_raw (sb))
+	return -EPERM;
+    if (INODE_PKEY(dir)->k_objectid != REISERFS_ROOT_OBJECTID ||
+	INODE_PKEY(dir)->k_dir_id != REISERFS_ROOT_PARENT_OBJECTID)
+	return -EPERM;
+    if ((error = permission (dir, MAY_EXEC)))
+	return error;
+
+    fd = get_unused_fd();
+    if (fd < 0)
+	return fd;
+
+    reiserfs_raw_id_correct (ra);
+    _make_cpu_key (&key, ITEM_VERSION_2,
+		   le32_to_cpu (ra->id1),
+		   le32_to_cpu (ra->id2),
+		   SD_OFFSET, TYPE_STAT_DATA, 3/*key length*/);
+    inode = reiserfs_iget (sb, &key);
+    if (IS_ERR (inode)) {
+	error = PTR_ERR (inode);
+	goto cleanup_fd;
+    }
+    if (!inode->i_nlink) {	/* unlinked */
+	/* reiserfs_read_inode2 should have caught such inode */
+	reiserfs_warning ("sizif-174: iget fetched unlinked file?\n");
+	goto cleanup_inode;
+    }
+
+    dentry = d_alloc_root(inode);
+    if (! dentry) {
+        error = -ENOMEM;
+	goto cleanup_inode;
+    }
+
+    filp = dentry_open(dentry, mntget(mnt), O_RDWR);
+    error = PTR_ERR(filp);
+    if (IS_ERR(filp))
+	goto cleanup_inode;
+
+    ra->lastref = inode->u.reiserfs_i.lastref;
+    ra->expires	= inode->u.reiserfs_i.expires;
+    ra->user1	= inode->u.reiserfs_i.user1;
+    ra->size    = inode->i_size;
+
+    /* lastref update is relatively expensive.  Don't do it if not
+       using PGC. */
+    if (sb->u.reiserfs_sb.pgc) {
+	time_t _pgc_current_time = pgc_current_time (sb);
+	if (inode->u.reiserfs_i.lastref != _pgc_current_time) {
+	    /*
+	     * Write out stat data and age counters in one transaction
+	     */
+	    int windex ;
+	    struct reiserfs_transaction_handle th ;
+	    int jbegin_count = JOURNAL_PER_BALANCE_CNT * 3; 
+	
+	    journal_begin (&th, sb, jbegin_count) ;
+	    windex = push_journal_writer("rawopen");
+	    inode->u.reiserfs_i.lastref = _pgc_current_time;
+	    pgc_age_class_update (&th, ra->lastref, inode->u.reiserfs_i.lastref);
+	    reiserfs_update_sd (&th, inode);
+	    pop_journal_writer (windex) ;
+	    journal_end (&th, sb, jbegin_count) ;
+	}
+    }
+
+    pgc_process_unlinkq (sb);
+    fd_install(fd, filp);
+    return fd;
+
+ cleanup_inode:
+    iput (inode);
+ cleanup_fd:
+    pgc_process_unlinkq (sb);
+    put_unused_fd (fd);
+    return error;
+}
+
+
+/* Set attributes for raw file. */
+
+int
+reiserfs_rawsetattr (struct inode * dir, struct reiserfs_raw_ioctl_arg *ra)
+{
+    struct super_block * sb = dir->i_sb;
+    struct cpu_key key;
+    struct inode *inode;
+    int ret;
+
+    if (! reiserfs_raw (sb))
+	return -EPERM;
+    if ((current->fsuid != dir->i_uid) && !capable(CAP_FOWNER))
+	return -EACCES;
+    if (! ra->lastref)
+	return -EINVAL;	/* 0 is special for pgc_age_class_update */
+    if (INODE_PKEY(dir)->k_objectid != REISERFS_ROOT_OBJECTID ||
+	INODE_PKEY(dir)->k_dir_id != REISERFS_ROOT_PARENT_OBJECTID)
+	return -EPERM;
+
+    reiserfs_raw_id_correct (ra);
+    _make_cpu_key (&key, ITEM_VERSION_2,
+		   le32_to_cpu (ra->id1),
+		   le32_to_cpu (ra->id2),
+		   SD_OFFSET, TYPE_STAT_DATA, 3/*key length*/);
+    inode = reiserfs_iget (sb, &key);
+    if (IS_ERR (inode))
+	return PTR_ERR (inode);
+
+    ret = reiserfs_rawsetattr2 (inode, ra);
+
+    iput (inode);
+    return ret;
+}
+
+	
+/* Set attributes for open raw file. */
+
+int
+reiserfs_rawsetattr_f (struct inode * inode, struct reiserfs_raw_ioctl_arg *ra)
+{
+    struct super_block * sb = inode->i_sb;
+
+    if (! reiserfs_raw (sb))
+	return -EPERM;
+    if ((current->fsuid != inode->i_uid) && !capable(CAP_FOWNER))
+	return -EACCES;
+    if (! ra->lastref)
+	return -EINVAL;	/* 0 is special for pgc_age_class_update */
+    if (! inode->u.reiserfs_i.lastref) /* not a raw file */
+	return -EPERM;
+
+    return reiserfs_rawsetattr2 (inode, ra);
+}
+
+
+/* Common part of reiserfs_rawsetattr{,_f} */
+
+int
+reiserfs_rawsetattr2 (struct inode * inode, struct reiserfs_raw_ioctl_arg *ra)
+{
+    struct super_block * sb = inode->i_sb;
+    int dirty = 0;
+    int lastref_dirty = 0;
+    unsigned old_lastref = 0;
+
+    if (inode->u.reiserfs_i.lastref != ra->lastref) {
+	old_lastref = inode->u.reiserfs_i.lastref;
+	inode->u.reiserfs_i.lastref = ra->lastref;
+	lastref_dirty = 1;
+    }
+    if (inode->u.reiserfs_i.expires != ra->expires) {
+	inode->u.reiserfs_i.expires = ra->expires;
+	dirty = 1;
+    }
+    if (inode->u.reiserfs_i.user1 != ra->user1) {
+	inode->u.reiserfs_i.user1 = ra->user1;
+	dirty = 1;
+    }
+
+    if (lastref_dirty) {
+	/*
+	 * Write out stat data and age counters in one transaction
+	 */
+	int windex ;
+	struct reiserfs_transaction_handle th ;
+	int jbegin_count = JOURNAL_PER_BALANCE_CNT * 3; 
+	
+	journal_begin (&th, sb, jbegin_count) ;
+	windex = push_journal_writer("rawsetattr");
+	pgc_age_class_update (&th, old_lastref, inode->u.reiserfs_i.lastref);
+	reiserfs_update_sd (&th, inode);
+	pop_journal_writer (windex) ;
+	journal_end (&th, sb, jbegin_count) ;
+    }
+    else if (dirty) {
+	/* lastref unchanged -- no age class update.  Somebody else
+           will take care of it. */
+	mark_inode_dirty(inode);
+    }
+
+    pgc_process_unlinkq (sb);
+    return 0;
+}
+
+
+
+/* Unlink raw file. */
+
+int
+reiserfs_rawunlink (struct inode * dir, struct reiserfs_raw_ioctl_arg *ra)
+{
+    struct super_block *sb = dir->i_sb;
+    struct cpu_key key;
+    int error;
+
+    if (! reiserfs_raw (sb))
+	return -EPERM;
+    if (INODE_PKEY(dir)->k_objectid != REISERFS_ROOT_OBJECTID ||
+	INODE_PKEY(dir)->k_dir_id != REISERFS_ROOT_PARENT_OBJECTID)
+	return -EPERM;
+    if ((error = permission (dir, MAY_WRITE)))
+	return error;
+
+    reiserfs_raw_id_correct (ra);
+    _make_cpu_key (&key, ITEM_VERSION_2,
+		   le32_to_cpu (ra->id1),
+		   le32_to_cpu (ra->id2),
+		   SD_OFFSET, TYPE_STAT_DATA, 3/*key length*/);
+    error = reiserfs_rawunlink2 (reiserfs_iget (sb, &key));
+
+    pgc_process_unlinkq (sb);
+    return error;
+}
+
+
+/* The bottom part of reiserfs_rawunlink, also used by pgc_process_unlinkq */
+
+int
+reiserfs_rawunlink2 (struct inode * inode)
+{
+    if (IS_ERR (inode))
+	return PTR_ERR (inode);
+    if (!inode->u.reiserfs_i.lastref) {
+	/* Not a raw file.  Unlinking it the way we do would leave
+           dangling directory entry, so disallow that */
+	iput (inode);
+	return -EINVAL;
+    }
+    if (!inode->i_nlink) {
+        reiserfs_warning ("sizif-380: iget fetched unlinked file? (from %p)\n",
+			  __builtin_return_address(0));
+	goto iput_and_out;	/* already deleted */
+    }
+    inode->i_nlink--;
+    if (inode->i_nlink != 0) {
+	reiserfs_warning ("sizif-385: raw file with i_nlink=%d?\n", inode->i_nlink+1);
+	goto iput_and_out;
+    }
+
+    /* Actually we need more work here.  Suppose process P1 has a file
+       open.  Another process (P2) tries to create a file with the
+       same id, gets EEXIST, and responds as squid/butterfly would by
+       issuing unlink() to get the file out of the way.  This will
+       result in i_nlink going to zero, but inode will still be in
+       inode cache, and its stat data on the disk will be intact until
+       P1 closes the file.  So if P2 retries its file creation attempt
+       right after the unlink(), it will still get EEXIST!  This
+       weirdness is due to the absence of directories.  One solution
+       might be to sleep in create() waiting for file to be removed,
+       but that's smelling like Windows... */
+
+    /*
+     * Write out stat data and age counters in one transaction
+     */
+    {
+	int windex ;
+	struct reiserfs_transaction_handle th ;
+	int jbegin_count = JOURNAL_PER_BALANCE_CNT * 3; 
+	struct super_block *sb = inode->i_sb;
+
+	journal_begin (&th, sb, jbegin_count) ;
+	windex = push_journal_writer("rawunlink2");
+	pgc_age_class_update (&th, inode->u.reiserfs_i.lastref, 0);
+	reiserfs_update_sd (&th, inode);
+	pop_journal_writer (windex) ;
+	journal_end (&th, sb, jbegin_count) ;
+    }
+
+ iput_and_out:
+    iput (inode);
+    return 0;
+}
+
+
+/* Our simplified reiserfs_new_inode ().  The differences are:
+ *  * we accept pre-generated SD key
+ *  * we only create regular files, so skipping directory/symlink handling
+ *  * we set inode attributes from supplied data
+
+This needs to be changed to use its own stat data item type with fewer
+fields, but this is not a priority.  There are hacks in here that will
+become cleaner code if we use a new item type instead of engaging in
+some pretense of using an older stat data item type. -Hans
+
+  */
+static struct inode *
+reiserfs_raw_new_inode (struct reiserfs_transaction_handle *th,
+			struct inode *dir,
+			struct cpu_key *key,
+			struct inode *inode,
+			struct reiserfs_raw_ioctl_arg *ra,
+			int * err)
+{
+    struct super_block *sb = dir->i_sb;
+    INITIALIZE_PATH (path_to_key);
+    char sdbuf[RAW_SD_SIZE];
+    struct stat_data *sd = (void *)sdbuf;
+    struct item_head ih;
+    int retval;
+
+    /* We only work with new format */
+    if (old_format_only (sb)) {
+        /* "cannot happen": we should have caught this when mounting
+           in raw mode */
+	reiserfs_warning ("sizif-453: 3.5 superblock?\n");
+	*err = -EFAULT;
+	iput(inode) ;
+	return NULL;
+    }
+
+    inode->i_sb = sb;
+    inode->i_flags = 0;
+
+    /* item head of new item */
+    ih.ih_key.k_dir_id = key->on_disk_key.k_dir_id;
+    ih.ih_key.k_objectid = key->on_disk_key.k_objectid;
+    make_le_item_head (&ih, 0, ITEM_VERSION_2, SD_OFFSET, TYPE_STAT_DATA,
+		       RAW_SD_SIZE, MAX_US_INT);
+
+    retval = search_item (sb, key, &path_to_key);
+    if (retval == IO_ERROR) {
+	iput (inode);
+	*err = -EIO;
+	return NULL;
+    }
+    if (retval == ITEM_FOUND) {
+	pathrelse (&path_to_key);
+	iput (inode);
+	*err = -EEXIST;
+	return NULL;
+    }
+
+    /* fill stat data */
+    inode->i_mode = S_IFREG|0600;
+    inode->i_nlink = 1;
+    inode->i_uid = current->fsuid;
+    inode->i_gid = (dir->i_mode & S_ISGID) ? dir->i_gid: current->fsgid;
+
+    inode->i_atime = inode->i_mtime = inode->i_ctime = CURRENT_TIME;
+    inode->i_size = 0;
+    inode->i_blocks = 0;
+    inode->u.reiserfs_i.i_first_direct_byte = U32_MAX;
+    inode2sd (sd, inode);
+
+    inode->u.reiserfs_i.lastref = pgc_current_time (sb);
+    inode->u.reiserfs_i.expires = ra->expires;
+    inode->u.reiserfs_i.user1   = ra->user1;
+    ATTR_LASTREF(sd) = cpu_to_le32 (inode->u.reiserfs_i.lastref);
+    ATTR_EXPIRES(sd) = cpu_to_le32 (ra->expires);
+    ATTR_USER1(sd)   = cpu_to_le32 (ra->user1);
+
+    // these do not go to on-disk stat data
+    inode->i_ino = le32_to_cpu (ih.ih_key.k_objectid);
+    inode->i_dev = sb->s_dev;
+    inode->i_blksize = sb->s_blocksize;
+    memcpy (INODE_PKEY (inode), &(ih.ih_key), KEY_SIZE);
+    inode_items_version (inode) = ITEM_VERSION_2;
+
+    /* insert the stat data into the tree */
+    retval = reiserfs_insert_item (th, &path_to_key, key, &ih, sdbuf);
+    if (retval) {
+	iput (inode);
+	*err = retval;
+	reiserfs_check_path(&path_to_key) ;
+	return NULL;
+    }
+
+    pgc_age_class_update (th, 0, inode->u.reiserfs_i.lastref);
+
+    /* TODO? inode->i_generation = INODE_PKEY (inode)->k_dir_id; */
+    insert_inode_hash (inode);
+    reiserfs_check_path(&path_to_key) ;
+    return inode;
+}
+
+/* Remap known bad ids to some other ids.  Thus we avoid the "id
+   cannot be created even if you remove old file with this id"
+   situation, at the price of increasing collision probability for the
+   ids that we remap to.  */
+
+static void
+reiserfs_raw_id_correct (struct reiserfs_raw_ioctl_arg *ra)
+{
+    if (ra->id1 == REISERFS_ROOT_PARENT_OBJECTID &&
+	ra->id2 == REISERFS_ROOT_OBJECTID) {
+	ra->id1 += 12345;
+    }
+#define SAFESAFE
+#ifdef SAFESAFE
+    if (ra->id1 <= 1) ra->id1 += 2;
+    if (ra->id2 <= 1) ra->id2 += 2;
+#else
+    /* bravely assuming [0,0], etc. are OK */
+#endif
+}
+
+
+/* The following is a good stuff but should REALLY be moved out of
+   here.  It is unrelated to reiserfs.  --sizif */
+
+/* non-portable extension of sigtimedwait to get many siginfo's per
+   one call.  Probably will improve (K)AIO performance.  
+*/
+int
+reiserfs_sigtimedwait(struct inode * dir, struct reiserfs_sigtimedwait_arg *arg)
+{
+  int i;
+  int ret, sig;
+  sigset_t these;
+  struct timespec ts;
+  siginfo_t info;
+  long timeout = 0;
+  
+  if( arg -> uinfos <= 0 )
+	{
+	  return -EINVAL;
+	}
+
+  /* XXX: Don't preclude handling different sized sigset_t's.  */
+  if( arg -> sigsetsize != sizeof( sigset_t ) )
+	return -EINVAL;
+
+  if( copy_from_user( &these, arg -> uthese, sizeof( these ) ) )
+	return -EFAULT;
+		
+  /*
+   * Invert the set of allowed signals to get those we
+   * want to block.
+   */
+  sigdelsetmask(&these, sigmask(SIGKILL)|sigmask(SIGSTOP));
+  signotset(&these);
+
+  timeout = MAX_SCHEDULE_TIMEOUT;
+  if( arg -> uts ) {
+	if( copy_from_user( &ts, arg -> uts, sizeof( ts ) ) )
+	  return -EFAULT;
+	if( ts.tv_nsec >= 1000000000L || ts.tv_nsec < 0 || ts.tv_sec < 0)
+	  return -EINVAL;
+  }
+
+  ret = 0;
+  for( i = 0 ; i < arg -> uinfos ; ++i )
+	{
+	  spin_lock_irq(&current->sigmask_lock);
+	  sig = dequeue_signal(&these, &info);
+	  /* sleep, but only for the first time */
+	  if (!sig && !i) 
+		{
+		  /* None ready -- temporarily unblock those we're interested
+			 in so that we'll be awakened when they arrive.  */
+		  timeout = (timespec_to_jiffies(&ts) + (ts.tv_sec || ts.tv_nsec));
+		  if( timeout )
+			{
+			  sigset_t oldblocked = current->blocked;
+			  sigandsets(&current->blocked, &current->blocked, &these);
+			  recalc_sigpending(current);
+			  spin_unlock_irq(&current->sigmask_lock);
+
+			  current->state = TASK_INTERRUPTIBLE;
+			  timeout = schedule_timeout(timeout);
+	
+			  spin_lock_irq(&current->sigmask_lock);
+			  sig = dequeue_signal(&these, &info);
+			  recalc_sigpending(current);
+			  current->blocked = oldblocked;
+			}
+		}
+	  spin_unlock_irq(&current->sigmask_lock);
+
+	  if (sig) {
+		ret = i + 1;
+		if( arg -> uinfo ) {
+		  if (copy_to_user( &arg -> uinfo[ i ], &info, sizeof info))
+			{
+			  ret = -EFAULT;
+			  break;
+			}
+		}
+	  } else {
+		if( i == 0 )
+		  {
+			ret = -EAGAIN;
+			if (timeout)
+			  ret = -EINTR;
+		  }
+		break;
+	  }
+	}
+  return ret;
+}
diff -rupN /usr/src/linux-2.4.9/fs/reiserfs/stree.c linux-kgdb/fs/reiserfs/stree.c
--- /usr/src/linux-2.4.9/fs/reiserfs/stree.c	Sat Jul 21 20:20:56 2001
+++ linux-kgdb/fs/reiserfs/stree.c	Sat Aug 25 18:41:48 2001
@@ -734,6 +734,15 @@ int search_by_key (struct super_block * 
 	    return IO_ERROR;
 	}
 
+#ifdef CONFIG_REISERFS_RAW
+        /* PGC: glance through the buffer looking for aged files' stat
+           data.  If any found, we'll remove them at once.  */
+        if (p_s_sb->u.reiserfs_sb.pgc
+            && B_LEVEL (p_s_bh) == DISK_LEAF_NODE_LEVEL) {
+            pgc_scan_buffer (p_s_sb, p_s_bh);
+        }
+#endif /* CONFIG_REISERFS_RAW */
+
 	/* It is possible that schedule occurred. We must check whether the key
 	   to search is still in the tree rooted from the current buffer. If
 	   not then repeat search from the root. */
diff -rupN /usr/src/linux-2.4.9/fs/reiserfs/super.c linux-kgdb/fs/reiserfs/super.c
--- /usr/src/linux-2.4.9/fs/reiserfs/super.c	Sat Jul 21 20:20:00 2001
+++ linux-kgdb/fs/reiserfs/super.c	Sun Aug 26 00:15:29 2001
@@ -112,7 +112,11 @@ void reiserfs_put_super (struct super_bl
     s->u.reiserfs_sb.s_rs->s_state = le16_to_cpu (s->u.reiserfs_sb.s_mount_state);
     journal_mark_dirty(&th, s, SB_BUFFER_WITH_SB (s));
   }
-
+#ifdef CONFIG_REISERFS_RAW
+  if (s->u.reiserfs_sb.pgc)
+      pgc_cleanup (s, (s->s_flags & MS_RDONLY)? NULL: &th);
+#endif
+    
   /* note, journal_release checks for readonly mount, and can decide not
   ** to do a journal_end
   */
@@ -154,13 +158,21 @@ struct super_operations reiserfs_sops = 
 
 };
 
+/* return values from parse_options */
+struct mount_options
+{
+   unsigned long blocks;       /* arg of resize= */
+   int pgclo;                  /* 1st arg of pgc=, low threshold */
+   int pgchi;                  /* 2nd arg of pgc=, high threshold */
+};
+
 /* this was (ext2)parse_options */
-static int parse_options (char * options, unsigned long * mount_options, unsigned long * blocks)
+static int parse_options (char * options, unsigned long * mount_options, struct mount_options * mop)
 {
     char * this_char;
     char * value;
   
-    *blocks = 0;
+    memset (mop, 0, sizeof (*mop));
     if (!options)
 	/* use default configuration: create tails, journaling on, no
            conversion to newest format */
@@ -193,7 +205,7 @@ static int parse_options (char * options
 	    set_bit (REPLAYONLY, mount_options);
 	} else if (!strcmp (this_char, "resize")) {
 	    if (value && *value){
-		*blocks = simple_strtoul (value, &value, 0);
+		mop->blocks = simple_strtoul (value, &value, 0);
 	    } else {
 	  	printk("reiserfs: resize option requires a value\n");
 		return 0;
@@ -222,6 +234,29 @@ static int parse_options (char * options
 	  	printk("reiserfs: hash option requires a value\n");
 		return 0 ;
 	    }
+#ifdef CONFIG_REISERFS_RAW
+        } else if (!strcmp (this_char, "raw")) {
+            set_bit (REISERFS_RAW, mount_options);
+        } else if (!strcmp (this_char, "pgc")) {
+            if (! value) {
+            pgc_usage:
+                printk("reiserfs: Usage: pgc=LOW,HIGH\n");
+                return 0;
+            }
+            mop->pgclo = simple_strtoul (value, &value, 10);
+            if (*value != '\0')
+                goto pgc_usage;
+            value = strtok (NULL, ",");
+            if (!value)
+                goto pgc_usage;
+            mop->pgchi = simple_strtoul (value, &value, 10);
+            if (mop->pgclo <= 0 || mop->pgchi < mop->pgclo || mop->pgchi > 100) {
+                printk("reiserfs: pgc: bad parameters\n");
+                return 0;
+            }
+            if (*value != '\0')
+                goto pgc_usage;
+#endif /* CONFIG_REISERFS_RAW */
 	} else {
 	    printk ("reiserfs: Unrecognized mount option %s\n", this_char);
 	    return 0;
@@ -247,20 +282,24 @@ int reiserfs_remount (struct super_block
 {
   struct reiserfs_super_block * rs;
   struct reiserfs_transaction_handle th ;
-  unsigned long blocks;
+  struct mount_options mo;
   unsigned long mount_options;
 
   rs = SB_DISK_SUPER_BLOCK (s);
 
-  if (!parse_options(data, &mount_options, &blocks))
+  if (!parse_options(data, &mount_options, &mo))
   	return 0;
 
-  if(blocks) {
-      int rc = reiserfs_resize(s, blocks);
+  if(mo.blocks) {
+      int rc = reiserfs_resize(s, mo.blocks);
       if (rc != 0)
 	  return rc;
   }
-
+#if defined( CONFIG_REISERFS_RAW )
+  if (mo.pgclo)
+      pgc_set_thresholds (s, mo.pgclo, mo.pgchi);
+#endif
+    
   if ((unsigned long)(*flags & MS_RDONLY) == (s->s_flags & MS_RDONLY)) {
     /* there is nothing to do to remount read-only fs as read-only fs */
     return 0;
@@ -687,18 +726,18 @@ struct super_block * reiserfs_read_super
     extern int *blksize_size[];
     struct reiserfs_transaction_handle th ;
     int old_format = 0;
-    unsigned long blocks;
+    struct mount_options mo;
     int jinit_done = 0 ;
     struct reiserfs_iget4_args args ;
 
 
     memset (&s->u.reiserfs_sb, 0, sizeof (struct reiserfs_sb_info));
 
-    if (parse_options ((char *) data, &(s->u.reiserfs_sb.s_mount_opt), &blocks) == 0) {
+    if (parse_options ((char *) data, &(s->u.reiserfs_sb.s_mount_opt), &mo) == 0) {
 	return NULL;
     }
 
-    if (blocks) {
+    if (mo.blocks) {
   	printk("reserfs: resize option for remount only\n");
 	return NULL;
     }	
@@ -768,7 +807,11 @@ struct super_block * reiserfs_read_super
 	iput(root_inode);
 	goto error;
     }
-
+    if (reiserfs_raw(s) && old_format_only(s)) {
+        printk ("-o raw cannot be used with reiserfs < 3.6\n");
+        goto error;
+    }
+    
     // define and initialize hash function
     s->u.reiserfs_sb.s_hash_function = hash_function (s);
     if (s->u.reiserfs_sb.s_hash_function == NULL) {
@@ -821,6 +864,14 @@ struct super_block * reiserfs_read_super
 
     init_waitqueue_head (&(s->u.reiserfs_sb.s_wait));
 
+#ifdef CONFIG_REISERFS_RAW
+    if (mo.pgclo) {
+        if (pgc_init (s) < 0)
+          goto error;
+       pgc_set_thresholds (s, mo.pgclo, mo.pgchi);
+    }
+#endif
+    
     printk("%s\n", reiserfs_get_version_string()) ;
     return s;
 
diff -rupN /usr/src/linux-2.4.9/fs/super.c linux-kgdb/fs/super.c
--- /usr/src/linux-2.4.9/fs/super.c	Sat Aug 11 15:52:46 2001
+++ linux-kgdb/fs/super.c	Sun Aug 26 19:26:28 2001
@@ -700,6 +700,7 @@ void sync_supers(kdev_t dev)
 		}
 		return;
 	}
+        /* KERNEL_ASSERT("kernel lock not held", KA_HELD_GKL()); */
 restart:
 	spin_lock(&sb_lock);
 	sb = sb_entry(super_blocks.next);
@@ -728,6 +729,7 @@ struct super_block * get_super(kdev_t de
 {
 	struct super_block * s;
 
+	/* KERNEL_ASSERT("kernel lock not held", KA_HELD_GKL()); */
 	if (!dev)
 		return NULL;
 restart:
diff -rupN /usr/src/linux-2.4.9/include/asm/errno.h linux-kgdb/include/asm/errno.h
--- /usr/src/linux-2.4.9/include/asm/errno.h	Fri Feb  9 21:40:02 2001
+++ linux-kgdb/include/asm/errno.h	Sun Aug 26 01:06:23 2001
@@ -129,4 +129,8 @@
 #define	ENOMEDIUM	123	/* No medium found */
 #define	EMEDIUMTYPE	124	/* Wrong medium type */
 
+#if defined(CONFIG_AIO)
+#define ECANCELED	125	/* Async I/O: operation canceled */
+#endif /* CONFIG_AIO */
+
 #endif
diff -rupN /usr/src/linux-2.4.9/include/asm/ioctls.h linux-kgdb/include/asm/ioctls.h
--- /usr/src/linux-2.4.9/include/asm/ioctls.h	Fri Jul 24 21:10:16 1998
+++ linux-kgdb/include/asm/ioctls.h	Sun Aug 26 18:21:42 2001
@@ -67,6 +67,7 @@
 #define TIOCGICOUNT	0x545D	/* read serial port inline interrupt counts */
 #define TIOCGHAYESESP   0x545E  /* Get Hayes ESP configuration */
 #define TIOCSHAYESESP   0x545F  /* Set Hayes ESP configuration */
+#define TIOCGDB         0x547F  /* enable GDB stub mode on this tty */
 
 /* Used for packet mode */
 #define TIOCPKT_DATA		 0
diff -rupN /usr/src/linux-2.4.9/include/asm/page.h linux-kgdb/include/asm/page.h
--- /usr/src/linux-2.4.9/include/asm/page.h	Fri Aug 24 00:13:23 2001
+++ linux-kgdb/include/asm/page.h	Sun Aug 26 18:40:11 2001
@@ -86,10 +86,14 @@ typedef struct { unsigned long pgprot; }
  * Tell the user there is some problem. Beep too, so we can
  * see^H^H^Hhear bugs in early bootup as well!
  */
+#ifdef CONFIG_X86_REMOTE_DEBUG
+#define BUG() KGDB_ASSERT("BUG", 0)
+#else
 #define BUG() do { \
 	printk("kernel BUG at %s:%d!\n", __FILE__, __LINE__); \
 	__asm__ __volatile__(".byte 0x0f,0x0b"); \
 } while (0)
+#endif
 
 #define PAGE_BUG(page) do { \
 	BUG(); \
diff -rupN /usr/src/linux-2.4.9/include/asm/processor.h linux-kgdb/include/asm/processor.h
--- /usr/src/linux-2.4.9/include/asm/processor.h	Fri Aug 24 00:23:39 2001
+++ linux-kgdb/include/asm/processor.h	Sun Aug 26 18:40:11 2001
@@ -379,6 +379,9 @@ struct thread_struct {
 /* IO permissions */
 	int		ioperm;
 	unsigned long	io_bitmap[IO_BITMAP_SIZE+1];
+#ifdef CONFIG_X86_REMOTE_DEBUG
+	struct pt_regs *kgdbregs;
+#endif
 };
 
 #define INIT_THREAD  {						\
diff -rupN /usr/src/linux-2.4.9/include/asm/unistd.h linux-kgdb/include/asm/unistd.h
--- /usr/src/linux-2.4.9/include/asm/unistd.h	Fri Aug 11 23:39:23 2000
+++ linux-kgdb/include/asm/unistd.h	Sun Aug 26 01:06:23 2001
@@ -228,6 +228,10 @@
 #define __NR_getdents64		220
 #define __NR_fcntl64		221
 
+#if defined(CONFIG_AIO)
+#define __NR_aio		251
+#endif
+
 /* user-visible error numbers are in the range -1 - -124: see <asm-i386/errno.h> */
 
 #define __syscall_return(type, res) \
diff -rupN /usr/src/linux-2.4.9/include/asm-i386/errno.h linux-kgdb/include/asm-i386/errno.h
--- /usr/src/linux-2.4.9/include/asm-i386/errno.h	Fri Feb  9 21:40:02 2001
+++ linux-kgdb/include/asm-i386/errno.h	Sun Aug 26 01:06:23 2001
@@ -129,4 +129,8 @@
 #define	ENOMEDIUM	123	/* No medium found */
 #define	EMEDIUMTYPE	124	/* Wrong medium type */
 
+#if defined(CONFIG_AIO)
+#define ECANCELED	125	/* Async I/O: operation canceled */
+#endif /* CONFIG_AIO */
+
 #endif
diff -rupN /usr/src/linux-2.4.9/include/asm-i386/ioctls.h linux-kgdb/include/asm-i386/ioctls.h
--- /usr/src/linux-2.4.9/include/asm-i386/ioctls.h	Fri Jul 24 21:10:16 1998
+++ linux-kgdb/include/asm-i386/ioctls.h	Sun Aug 26 18:21:42 2001
@@ -67,6 +67,7 @@
 #define TIOCGICOUNT	0x545D	/* read serial port inline interrupt counts */
 #define TIOCGHAYESESP   0x545E  /* Get Hayes ESP configuration */
 #define TIOCSHAYESESP   0x545F  /* Set Hayes ESP configuration */
+#define TIOCGDB         0x547F  /* enable GDB stub mode on this tty */
 
 /* Used for packet mode */
 #define TIOCPKT_DATA		 0
diff -rupN /usr/src/linux-2.4.9/include/asm-i386/page.h linux-kgdb/include/asm-i386/page.h
--- /usr/src/linux-2.4.9/include/asm-i386/page.h	Fri Aug 24 00:13:23 2001
+++ linux-kgdb/include/asm-i386/page.h	Sun Aug 26 18:40:11 2001
@@ -86,10 +86,14 @@ typedef struct { unsigned long pgprot; }
  * Tell the user there is some problem. Beep too, so we can
  * see^H^H^Hhear bugs in early bootup as well!
  */
+#ifdef CONFIG_X86_REMOTE_DEBUG
+#define BUG() KGDB_ASSERT("BUG", 0)
+#else
 #define BUG() do { \
 	printk("kernel BUG at %s:%d!\n", __FILE__, __LINE__); \
 	__asm__ __volatile__(".byte 0x0f,0x0b"); \
 } while (0)
+#endif
 
 #define PAGE_BUG(page) do { \
 	BUG(); \
diff -rupN /usr/src/linux-2.4.9/include/asm-i386/processor.h linux-kgdb/include/asm-i386/processor.h
--- /usr/src/linux-2.4.9/include/asm-i386/processor.h	Fri Aug 24 00:23:39 2001
+++ linux-kgdb/include/asm-i386/processor.h	Sun Aug 26 18:40:11 2001
@@ -379,6 +379,9 @@ struct thread_struct {
 /* IO permissions */
 	int		ioperm;
 	unsigned long	io_bitmap[IO_BITMAP_SIZE+1];
+#ifdef CONFIG_X86_REMOTE_DEBUG
+	struct pt_regs *kgdbregs;
+#endif
 };
 
 #define INIT_THREAD  {						\
diff -rupN /usr/src/linux-2.4.9/include/asm-i386/unistd.h linux-kgdb/include/asm-i386/unistd.h
--- /usr/src/linux-2.4.9/include/asm-i386/unistd.h	Fri Aug 11 23:39:23 2000
+++ linux-kgdb/include/asm-i386/unistd.h	Sun Aug 26 01:06:23 2001
@@ -228,6 +228,10 @@
 #define __NR_getdents64		220
 #define __NR_fcntl64		221
 
+#if defined(CONFIG_AIO)
+#define __NR_aio		251
+#endif
+
 /* user-visible error numbers are in the range -1 - -124: see <asm-i386/errno.h> */
 
 #define __syscall_return(type, res) \
